#[derive(Eq, PartialEq, Clone, Copy)]
pub enum RpsHand {
    Paper,
    Scissors,
    Rock,
}

impl RpsHand {
    pub fn loses_to(&self) -> RpsHand {
        match *self {
            RpsHand::Paper => RpsHand::Scissors,
            RpsHand::Scissors => RpsHand::Rock,
            RpsHand::Rock => RpsHand::Paper,
        }
    }
    pub fn wins_against(&self) -> RpsHand {
        match *self {
            RpsHand::Paper => RpsHand::Rock,
            RpsHand::Scissors => RpsHand::Paper,
            RpsHand::Rock => RpsHand::Scissors,
        }
    }
    pub fn ties_with(&self) -> RpsHand {
        *self
    }
}

pub enum Goal {
    Lose,
    Draw,
    Win,
}

#[derive(Eq, PartialEq)]
pub struct Game {
    pub opponent: RpsHand,
    pub mine: RpsHand,
}
