use std::collections::HashSet;
use std::collections::VecDeque;

static INPUT: &str = include_str!("input.txt");

fn solve(input: &str, n: usize) -> i32 {
    let mut position = 1;
    let mut buffer = input.chars().take(n).collect::<VecDeque<char>>();
    let mut datastream = input.chars();

    loop {
        let mut uniqs = HashSet::new();
        let pointer = datastream.next();
        match pointer {
            None => panic!("no header found"),
            Some(c) => {
                buffer.pop_front();
                buffer.push_back(c);
                let result = buffer.clone().into_iter().all(|x| uniqs.insert(x));
                if result {
                    return position;
                } else {
                    position += 1;
                    continue;
                }
            }
        }
    }
}

pub fn solution_a() -> i32 {
    solve(INPUT, 4)
}

pub fn solution_b() -> i32 {
    solve(INPUT, 14)
}
